QRDecomposition (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.linalg.QRDecomposition class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix.linalg
Class QRDecomposition

    java.lang.Object
      cern.colt.matrix.linalg.QRDecomposition

All Implemented Interfaces:
  Serializable

public class QRDecomposition
extends Object
implements Serializable

For an `m x n` matrix `A` with `m >= n`, the QR decomposition is an `m x n` orthogonal matrix `Q` and an `n x n` upper triangular matrix `R` so that `A = Q*R`.

The QR decompostion always exists, even if the matrix does not have full rank, so the constructor will never fail. The primary use of the QR decomposition is in the least squares solution of nonsquare systems of simultaneous linear equations. This will fail if `isFullRank()` returns `false`.

See Also:
  Serialized Form

Constructor Summary
`QRDecomposition(DoubleMatrix2D A)` Constructs and returns a new QR decomposition object; computed by Householder reflections; The decomposed matrices can be retrieved via instance methods of the returned decomposition object.

Method Summary
`DoubleMatrix2D` | `getH()` Returns the Householder vectors `H`.
`DoubleMatrix2D` | `getQ()` Generates and returns the (economy-sized) orthogonal factor `Q`.
`DoubleMatrix2D` | `getR()` Returns the upper triangular factor, `R`.
`boolean` | `hasFullRank()` Returns whether the matrix `A` has full rank.
`DoubleMatrix2D` | `solve(DoubleMatrix2D B)` Least squares solution of `A*X = B`; `returns X`.
`String` | `toString()` Returns a String with (propertyName, propertyValue) pairs.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### QRDecomposition

    public QRDecomposition(DoubleMatrix2D A)

  Constructs and returns a new QR decomposition object; computed by Householder reflections; The decomposed matrices can be retrieved via instance methods of the returned decomposition object.

Parameters:
  `A` - A rectangular matrix.
Throws:
  `IllegalArgumentException` - if `A.rows() < A.columns()`.

Method Detail

### getH

    public DoubleMatrix2D getH()

  Returns the Householder vectors `H`.

  Returns:
    A lower trapezoidal matrix whose columns define the householder reflections.

### getQ

    public DoubleMatrix2D getQ()

  Generates and returns the (economy-sized) orthogonal factor `Q`.

  Returns:
    `Q`

### getR

    public DoubleMatrix2D getR()

  Returns the upper triangular factor, `R`.

  Returns:
    `R`

### hasFullRank

    public boolean hasFullRank()

  Returns whether the matrix `A` has full rank.

  Returns:
    true if `R`, and hence `A`, has full rank.

### solve

    public DoubleMatrix2D solve(DoubleMatrix2D B)

  Least squares solution of `A*X = B`; `returns X`.

  Parameters:
    `B` - A matrix with as many rows as `A` and any number of columns.
  Returns:
    `X` that minimizes the two norm of `Q*R*X - B`.
  Throws:
    `IllegalArgumentException` - if `B.rows() != A.rows()`.
    `IllegalArgumentException` - if `!this.hasFullRank()` (`A` is rank deficient).

### toString

    public String toString()

  Returns a String with (propertyName, propertyValue) pairs. Useful for debugging or to quickly get the rough picture. For example,

      rank          : 3
      trace         : 0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage